Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/Application.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/Application.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/Application.java	(revision 3628)
@@ -38,6 +38,7 @@
 
 import org.eclipse.core.net.proxy.IProxyService;
 import org.eclipse.core.runtime.Platform;
+import org.eclipse.core.runtime.Status;
 import org.eclipse.core.runtime.preferences.ConfigurationScope;
 import org.eclipse.equinox.app.IApplication;
 import org.eclipse.equinox.app.IApplicationContext;
@@ -48,7 +49,6 @@
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.MessageBox;
 import org.eclipse.swt.widgets.Shell;
-import org.eclipse.ui.IWorkbench;
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.internal.ide.ChooseWorkspaceData;
 import org.eclipse.ui.internal.ide.IDEWorkbenchPlugin;
@@ -59,10 +59,19 @@
 import org.txm.Toolbox;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.preferences.TBXPreferences;
+import org.txm.objects.Project;
+import org.txm.objects.Workspace;
+import org.txm.rcp.commands.workspace.Load080BinaryCorpus;
+import org.txm.rcp.handlers.scripts.ExecuteImportScript;
 import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.rcp.preferences.RCPPreferences;
 import org.txm.rcp.swt.dialog.CGUMessageDialog;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.searchengine.cqp.CQPSearchEngine;
+import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
+import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.utils.BundleUtils;
+import org.txm.utils.LogMonitor;
 import org.txm.utils.logger.Log;
 
 
@@ -72,12 +81,16 @@
 public class Application implements IApplication {
 	/** The Constant PLUGIN_ID. */
 	public static final String PLUGIN_ID = "org.txm.rcp"; //$NON-NLS-1$
-	
+
 	/** The Constant FIRST_LAUNCH. */
 	public static final String FIRST_LAUNCH = "first_launch"; //$NON-NLS-1$
-	
+
 	private static ApplicationWorkbenchAdvisor awa;
+
+	private static boolean headlessMode = false;
 	
+	private static boolean restMode = false;
+
 	// public static OpenDocumentEventProcessor openDocProcessor = new OpenDocumentEventProcessor();
 	/*
 	 * (non-Javadoc)
@@ -85,10 +98,29 @@
 	 */
 	@Override
 	public Object start(IApplicationContext context) throws Exception {
+
+		Map args = context.getArguments();
+		List<String> argsList = Arrays.asList((String[]) (args.get("application.args"))); //$NON-NLS-1$
+		System.out.println(TXMCoreMessages.bind(TXMUIMessages.argsColon, argsList));
+
+		headlessMode = argsList.contains("--headless");
+		if (headlessMode) {
+			return startHeadLess(argsList);
+		}
 		
+		restMode = argsList.contains("--rest");
+		if (restMode) {
+			return startRest(argsList);
+		}
+
+		return startDesktop(argsList);
+	}
+
+	private int startDesktop(List<String> argsList) {
+		// if not headless continue as usual for the Desktop version to start
 		Display display = PlatformUI.createDisplay();
-		
-		
+
+
 		// if (Platform.inDevelopmentMode() || Platform.inDebugMode()) {
 		// // this can not work in development environment
 		// // as it need to have a default workspace set to none
@@ -100,10 +132,10 @@
 		// } else {
 		// in Release mode only : platform workspace selection on startup
 		// then restart if needed (on workspace error...)
-		
+
 		System.out.println("instance location=" + Platform.getInstanceLocation().getURL()); //$NON-NLS-1$
 		if (Platform.getInstanceLocation().getURL() == null) {
-			
+
 			Integer ret = openCGU();
 			if (ret == IApplication.EXIT_RESTART) {
 				System.out.println("** Working directory set by user."); //$NON-NLS-1$
@@ -117,23 +149,23 @@
 				// OK
 			}
 		}
-		
+
 		// Die if platform WS not set (user cancel)
 		// ---------------------------
-		
+
 		if (Platform.getInstanceLocation().getURL() == null) {
 			System.out.println("** Working directory not set."); //$NON-NLS-1$
 			return IApplication.EXIT_OK;
 		}
-		
-		
+
+
 		// load JVM fonts in SWT env
 		if (System.getProperty("os.name").contains("Linux")) { // $NON-NLS-1$ $NON-NLS-2$ //$NON-NLS-1$ //$NON-NLS-2$
 			File javaFontsPath = new File(System.getProperty("java.home") //$NON-NLS-1$
 					+ System.getProperty("file.separator") + "lib" //$NON-NLS-1$ //$NON-NLS-2$
 					+ System.getProperty("file.separator") + "fonts" //$NON-NLS-1$ //$NON-NLS-2$
 					+ System.getProperty("file.separator")); //$NON-NLS-1$
-			
+
 			String[] fontFiles = javaFontsPath.list();
 			if (fontFiles != null) {
 				for (int i = 0; i < fontFiles.length; i++) {
@@ -146,13 +178,7 @@
 				}
 			}
 		}
-		
-		Map args = context.getArguments();
-		
-		List<String> argsList = Arrays.asList((String[]) (args.get("application.args"))); //$NON-NLS-1$
-		
-		System.out.println(TXMCoreMessages.bind(TXMUIMessages.argsColon, argsList));
-		
+
 		if (argsList.contains("-log")) { //$NON-NLS-1$
 			System.out.println(TXMUIMessages.logOptionDetected);
 			Log.setPrintInConsole(true);
@@ -162,8 +188,10 @@
 			Toolbox.setPreference(TBXPreferences.LOG_LEVEL, "ALL"); //$NON-NLS-1$
 			Toolbox.setPreference(TBXPreferences.LOG_STACKTRACE, true);
 		}
-		
-		if (argsList.contains("-run") || System.getProperty("os.name").contains("Mac") || Platform.inDevelopmentMode()) { //$NON-NLS-1$
+
+		if (argsList.contains("-run") //$NON-NLS-1$
+				|| System.getProperty("os.name").contains("Mac") //$NON-NLS-1$
+				|| Platform.inDevelopmentMode()) { // special case when TXM is run with Eclipse
 			System.out.println("Running TXM"); //$NON-NLS-1$
 			// FIXME: need to check that all has been well moved in Workspace class or build.properties
 			// } else if (argsList.contains("-standalone")) { //$NON-NLS-1$
@@ -203,22 +231,22 @@
 		else {
 			System.err.println("TXM must be launch with the argument '-run' to start."); //$NON-NLS-1$
 			System.err.println(TXMUIMessages.thisFileIsNotMeantToRunTXMPleaseConsultTXMUserManual);
-			
+
 			javax.swing.JOptionPane.showMessageDialog(null, TXMUIMessages.thisFileIsNotMeantToRunTXMPleaseConsultTXMUserManual);
 			return IApplication.EXIT_OK;
 		}
 		// test if Java 1.6 is installed
 		String version = System.getProperty("java.version"); //$NON-NLS-1$
 		Log.warning("java.version : " + version); //$NON-NLS-1$
-		
+
 		boolean exit = false;// parseCommandLine();
 		if (exit) {
 			return IApplication.EXIT_OK;
 		}
-		
-		
+
+
 		// display.addListener(SWT.OpenDocument, openDocProcessor);
-		
+
 		// //Lock the RCP workspace, thus there is only one TXM instance running
 		// Log.warning(TXMUIMessages.lockRCPWorkspace);
 		// if (!Platform.getInstanceLocation().lock()){
@@ -226,7 +254,7 @@
 		// System.out.println("TXM is already running. Exiting...");
 		// return IApplication.EXIT_OK;
 		// }
-		
+
 		try {
 			Log.warning(TXMUIMessages.activateProxyService);
 			activateProxyService();
@@ -234,18 +262,19 @@
 		catch (Exception e) {
 			Log.warning(TXMCoreMessages.bind(TXMUIMessages.couldNotStartProxyConfigurationColon, e));
 		}
-		
+
 		try {			
 			// run the application mainloop
 			awa = new ApplicationWorkbenchAdvisor();
 			System.out.println("Running TXM workbench."); //$NON-NLS-1$
+
 			int returnCode = PlatformUI.createAndRunWorkbench(display, awa);
-			
+
 			if (returnCode == PlatformUI.RETURN_RESTART) {
 				System.out.println("Restarting TXM."); //$NON-NLS-1$
 				return IApplication.EXIT_RESTART;
 			}
-			
+
 			System.out.println("Exiting TXM."); //$NON-NLS-1$
 			return IApplication.EXIT_OK;
 		}
@@ -255,9 +284,182 @@
 		}
 	}
 	
+	private int startRest(List<String> argsList) throws IllegalStateException, IOException {
+		System.out.println("NOT IMPLEMENTED");
+		
+		return 0;
+	}
+
+	private int startHeadLess(List<String> argsList) throws IllegalStateException, IOException {
+
+		if (Toolbox.getTxmHomePath() == null || Toolbox.getTxmHomePath().isEmpty()) {
+			File txmhomedir = Platform.getLocation().toFile().getCanonicalFile();
+			TBXPreferences.getInstance().put(TBXPreferences.USER_TXM_HOME, txmhomedir.getAbsolutePath());
+		}
+		int ret = IApplication.EXIT_OK;
+
+		try {
+			if (Toolbox.initialize(TBXPreferences.class, new LogMonitor())) {
+
+				if (argsList.contains("--action=list")) {
+					ret = doList();
+				}
+
+				if (argsList.contains("--action=new")) {
+					String path = argsList.get(argsList.size() -2);
+					File sourcePath = new File(path);
+
+					String name = argsList.get(argsList.size() -1);
+					
+					ret = doNew(sourcePath, name);
+					
+				} else if (argsList.contains("--action=import")) {
+					String path = argsList.get(argsList.size() -1);
+					File sourcePath = new File(path);
+					
+					ret = doImport(sourcePath);
+				} else if (argsList.contains("--action=export")) {
+					String path = argsList.get(argsList.size() -1).trim();
+					ret = doExport(path);
+				} else if (argsList.contains("--action=remove")) {
+					String path = argsList.get(argsList.size() -1).trim();
+					ret = doRemove(path);
+				} else if (argsList.contains("--action=command")) {
+
+					String name = argsList.get(argsList.size() -2).trim();
+
+					String path = argsList.get(argsList.size() -1).trim();
+
+					ret = doCommand(name, path);
+				}
+
+				Toolbox.workspace.saveParameters(true);
+				Toolbox.shutdown();
+			} else {
+				Log.severe("Toolbox not initialized - good luck");
+			}
+		} catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+			ret = -1;
+		}
+
+		return ret;
+	}
+
+	private int doList() throws UnexpectedAnswerException, IOException, CqiServerError {
+		
+		System.out.println(Arrays.asList(CQPSearchEngine.getCqiClient().listCorpora()));
+		return IApplication.EXIT_OK;
+	}
+
+	private int doExport(String path) throws IOException {
+		
+		int ret = IApplication.EXIT_OK;
+		if (path.length() == 0) {
+			System.err.println("No corpus name provided.");
+			ret = -1;
+		} else {
+			Project p = Workspace.getInstance().getProject(path);
+			if (p == null) {
+				System.err.println("No corpus found with name: "+path);
+				ret = -1;
+			} else {
+				File f = new File(Toolbox.getTxmHomePath(), path+".txm");
+				p.export(f);
+				System.out.println("Exported file: "+f.getAbsolutePath());
+			}
+		}
+		return ret;
+	}
+
+	private int doCommand(String name, String path) {
+		
+		int ret = IApplication.EXIT_OK;
+		if (name.length() == 0) {
+			System.err.println("No command name parameter provided. Ex: concordance, index");
+			ret = -1;
+		} else if (path.length() == 0) {
+			System.err.println("No target path parameter provided. Ex: corpus path /VOEUX , concordance name /VOEUX/myconc");
+			ret = -1;
+		} else {
+			System.out.println("DO: "+name+ " WITH "+path);
+		}
+		return ret;
+	}
+
+	private int doRemove(String path) {
+		
+		int ret = IApplication.EXIT_OK;
+		
+		if (path.length() == 0) {
+			System.err.println("No corpus name provided.");
+			ret = -1;
+		} else {
+			Project p = Workspace.getInstance().getProject(path);
+			if (p == null) {
+				System.err.println("No corpus found with name: "+path);
+				ret = -1;
+			} else {
+				p.delete();
+				System.out.println("Deleted corpus: "+path);
+			}
+		}
+		return ret;
+	}
+
+	private int doImport(File sourcePath) throws Exception {
+		
+		int ret = IApplication.EXIT_OK;
+		if (!sourcePath.exists()) {
+			System.err.println("No TXM corpus file found: "+sourcePath);
+			ret = -1;
+		} else if (!sourcePath.canRead()) {
+			System.err.println("Cannot read TXM corpus file: "+sourcePath);
+			ret = -1;
+		} else if (!sourcePath.getName().endsWith(".txm") || !sourcePath.isFile()) {
+			System.err.println("Not a TXM corpus file: "+sourcePath);
+			ret = -1;
+		} else { // DO IT
+			Project p = Load080BinaryCorpus.loadBinaryCorpusArchive(sourcePath, new LogMonitor(), true);
+
+			if (p == null) {
+				ret = -1;
+			} 
+
+			System.out.println(Arrays.asList(CQPSearchEngine.getCqiClient().listCorpora()));
+			ret = 0;
+		}
+		return ret;
+	}
+
+	private int doNew(File sourcePath, String name) throws InterruptedException {
+		
+		int ret = IApplication.EXIT_OK;
+		
+		if (!sourcePath.exists()) {
+			System.err.println("No source directory found: "+sourcePath);
+			ret = -1;
+		} else if (!sourcePath.canRead()) {
+			System.err.println("Cannot read source directory: "+sourcePath);
+			ret = -1;
+		} else if (!sourcePath.isDirectory()) {
+			System.err.println("Not a source directory: "+sourcePath);
+			ret = -1;
+		} else { // DO IT
+			Project p = org.txm.rcp.corpuswizard.ImportWizard.doCreateProject(sourcePath, name);
+			p.setDirty();
+			JobHandler job = ExecuteImportScript.executeScript(p);
+			job.join();
+
+			ret = job.getResult() == Status.OK_STATUS ? IApplication.EXIT_OK:-1;
+		}
+		return ret;
+	}
+
 	private Integer openCGU() {
 		try {
-			
+
 			Version v = BundleUtils.getBundleVersion("org.txm.rcp");//$NON-NLS-1$
 			if (v == null) {
 				System.out.println("Error: no 'org.txm.rcp' version found."); //$NON-NLS-1$
@@ -269,11 +471,11 @@
 				version += "-dev"; //$NON-NLS-1$
 			}
 			System.out.println("Version=" + version); //$NON-NLS-1$
-			
+
 			File txmhomedir = new File(System.getProperty("user.home"), "TXM-" + version); //$NON-NLS-1$ //$NON-NLS-2$
-			
-			
-			
+
+
+
 			// System.out.println("CGU="+ConfigurationScope.INSTANCE.getNode(IDEWorkbenchPlugin.IDE_WORKBENCH).getBoolean(RCPPreferences.CGU, false));
 			if (!ConfigurationScope.INSTANCE.getNode(IDEWorkbenchPlugin.IDE_WORKBENCH).getBoolean(RCPPreferences.CGU, false)) {
 				ChooseWorkspaceData launchData = new ChooseWorkspaceData(txmhomedir.getAbsolutePath());
@@ -283,7 +485,7 @@
 				boolean ret = (dialog.open() == MessageDialog.OK) && dialog.hasCheckBeenPressed();
 				if (ret) {
 					// TBXPreferences.getInstance().put(RCPPreferences.CGU, true);
-					
+
 					// check choosen path
 					String path = launchData.getSelection();
 					if (path != null) { // reset the letadata file
@@ -296,19 +498,19 @@
 					if (ret2 != -1) {
 						return ret2;
 					}
-					
+
 					// validate Current as default Workspace, save configuration & history
-					
+
 					launchData.writePersistedData();
 					System.out.println("save workspace location: " + launchData.getSelection()); //$NON-NLS-1$
 					ChooseWorkspaceData.setShowDialogValue(false);
-					
+
 					Preferences node = ConfigurationScope.INSTANCE.getNode(IDEWorkbenchPlugin.IDE_WORKBENCH);
 					node.putBoolean(RCPPreferences.CGU, true);
 					node.flush();
-					
+
 					return -1;
-					
+
 				}
 				else {
 					return IApplication.EXIT_OK;
@@ -317,7 +519,7 @@
 			else {
 				ChooseWorkspaceData launchData = new ChooseWorkspaceData(txmhomedir.getAbsolutePath());
 				String[] recent = launchData.getRecentWorkspaces();
-				
+
 				// If the selection dialog was not used then the workspace to use is either the
 				// most recent selection or the initialDefault (if there is no history).
 				String workspace = null;
@@ -328,7 +530,7 @@
 					workspace = launchData.getInitialDefault();
 				}
 				launchData.workspaceSelected(TextProcessor.deprocess(workspace));
-				
+
 				return setInstanceLocation(launchData);
 			}
 		}
@@ -338,14 +540,14 @@
 			return IApplication.EXIT_OK;
 		}
 	}
-	
+
 	private Integer setInstanceLocation(ChooseWorkspaceData launchData) {
 		String selWS = launchData.getSelection();
 		if (selWS == null) {
 			System.out.println("** No workspace set in configuration scope."); //$NON-NLS-1$
 			return IApplication.EXIT_OK;// user cancelled (no restart)
 		}
-		
+
 		// Switch workspace :
 		URL url = null;
 		try {
@@ -355,12 +557,12 @@
 			showWorkspaceError("Workspace path could not be found."); //$NON-NLS-1$
 			return IApplication.EXIT_OK;
 		}
-		
+
 		try {
 			if (org.eclipse.core.runtime.Platform.inDevelopmentMode()) {
 				return -1; // can't call Platform.getInstanceLocation().set(...) in dev mode
 			}
-			
+
 			if (!Platform.getInstanceLocation().set(url, true)) {
 				showWorkspaceError("TXM is already running. Exiting..."); //$NON-NLS-1$
 				ChooseWorkspaceData.setShowDialogValue(false);
@@ -380,10 +582,10 @@
 			ChooseWorkspaceData.setShowDialogValue(true);
 			return IApplication.EXIT_OK;
 		}
-		
-		
+
+
 	}
-	
+
 	// /**
 	// * Open choose workspace dialog and validate the user's choice. Returns true
 	// * if restart needed.
@@ -436,30 +638,30 @@
 	// ChooseWorkspaceData.setShowDialogValue(false);
 	// return -1;// user cancelled (no restart)
 	// }
-	
+
 	private static void showWorkspaceError(String message) {
 		MessageBox messageBox = new MessageBox(new Shell(), SWT.DIALOG_TRIM | SWT.ERROR);
 		messageBox.setText(TXMUIMessages.TXTStartingError);
 		messageBox.setMessage(message);
 		messageBox.open();
 	}
-	
+
 	public ApplicationWorkbenchAdvisor getApplicationWorkbenchAdvisor() {
 		return awa;
 	}
-	
+
 	@Override
 	public void stop() {
 		// TODO Auto-generated method stub
-		
+
 	}
-	
+
 	/**
 	 * Activates the proxy service and sets the network connection active provider as native.
 	 */
 	private void activateProxyService() {
 		String systemProxyHost = System.getProperty("http.proxyHost"); // must be called before IProxyService is used //$NON-NLS-1$
-		
+
 		Bundle bundle = Platform.getBundle("org.eclipse.ui.ide"); //$NON-NLS-1$
 		IProxyService proxyService = null;
 		if (bundle != null) {
@@ -477,7 +679,7 @@
 				System.out.println("System proxy detected. Force network provider to manual with proxy_host=" + systemProxyHost); //$NON-NLS-1$
 				proxyService.setProxiesEnabled(true);
 			}
-			
+
 			// if (Util.isMac()) { // configure only for Mac OS X
 			// // String proxy_conf = "";
 			// // ProxyConf conf = new ProxyConf(this);
@@ -504,7 +706,11 @@
 			// }
 		}
 	}
-	
+
+	public static boolean isHeadLess() {
+		return headlessMode || restMode;
+	}
+
 	// /**
 	// * Parses the command line.
 	// *
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/corpuswizard/ImportWizard.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/corpuswizard/ImportWizard.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/corpuswizard/ImportWizard.java	(revision 3628)
@@ -41,114 +41,118 @@
 	@Override
 	public boolean performFinish() {
 		if (page1.isCompleted()) {
-			try {
-				File path = new File(page1.getSourcePath());
-				String name = page1.getCorpusName();// AsciiUtils.buildId(path.getName()).toUpperCase();
+			File path = new File(page1.getSourcePath());
+			String name = page1.getCorpusName();// AsciiUtils.buildId(path.getName()).toUpperCase();
+			project = doCreateProject(path, name);
+			return true;
+		}
+		return false;
+	}
+	
+	public static Project doCreateProject(File path, String name) {
+		try {
+			IProject rcpProject = ResourcesPlugin.getWorkspace().getRoot().getProject(name);
+			if (rcpProject.exists() && !rcpProject.isOpen()) {
+				rcpProject.open(new LogMonitor("Opening corpus for import")); //$NON-NLS-1$
+			}
+			Project project = null;
+			
+			// find last project using this src directory
+			for (Project p : Toolbox.workspace.getProjects()) {
+				File psrc = p.getSrcdir();
+				if (!path.equals(psrc)) {
+					continue;
+				}
+				if (!name.equals(p.getRCPProject().getName())) {
+					continue;
+				}
 				
-				IProject rcpProject = ResourcesPlugin.getWorkspace().getRoot().getProject(name);
-				if (rcpProject.exists() && !rcpProject.isOpen()) {
-					rcpProject.open(new LogMonitor("Opening corpus for import")); //$NON-NLS-1$
+				// get the more recent one
+				if (project != null && p.getLastComputingDate().compareTo(project.getLastComputingDate()) > 0) {
+					project = p;
 				}
-				project = null;
+				else {
+					project = p;
+				}
+			}
+			boolean newProject = (project == null);
+			if (newProject) { // it's a new project configuration
+				File settingsDirectory = new File(path, "parameters"); //$NON-NLS-1$
+				if (settingsDirectory.exists()) {
+					File settingsCopy = new File(Toolbox.workspace.getLocation(), name + "/.settings"); //$NON-NLS-1$
+					settingsCopy.getParentFile().mkdirs();
+					FileCopy.copyFiles(settingsDirectory, settingsCopy);
+				}
 				
-				// find last project using this src directory
-				for (Project p : Toolbox.workspace.getProjects()) {
-					File psrc = p.getSrcdir();
-					if (!path.equals(psrc)) {
-						continue;
-					}
-					if (!name.equals(p.getRCPProject().getName())) {
-						continue;
-					}
-					
-					// get the more recent one
-					if (project != null && p.getLastComputingDate().compareTo(project.getLastComputingDate()) > 0) {
-						project = p;
-					}
-					else {
-						project = p;
-					}
+				project = Toolbox.workspace.getProject(name);
+				if (project == null) {
+					project = new Project(Toolbox.workspace, name);
 				}
-				boolean newProject = (project == null);
-				if (newProject) { // it's a new project configuration
-					File settingsDirectory = new File(path, "parameters"); //$NON-NLS-1$
-					if (settingsDirectory.exists()) {
-						File settingsCopy = new File(Toolbox.workspace.getLocation(), name + "/.settings"); //$NON-NLS-1$
-						settingsCopy.getParentFile().mkdirs();
-						FileCopy.copyFiles(settingsDirectory, settingsCopy);
-					}
-					
-					project = Toolbox.workspace.getProject(name);
-					if (project == null) {
-						project = new Project(Toolbox.workspace, name);
-					}
-					project.setSourceDirectory(path.getAbsolutePath());
-					project.setDescription(NLS.bind(TXMUIMessages.DashImportedByP0, System.getProperty("user.name"))); //$NON-NLS-2$
-					project.setLang(Locale.getDefault().getLanguage().toLowerCase());
-					
-					project.getEditionDefinition("default").setEnableCollapsible(false); //$NON-NLS-1$
-					project.getEditionDefinition("default").setPageBreakTag("pb"); //$NON-NLS-1$ //$NON-NLS-2$
-					project.getEditionDefinition("default").setPaginateEdition(true); //$NON-NLS-1$
-					project.getEditionDefinition("default").setWordsPerPage(1000); //$NON-NLS-1$
-					project.getEditionDefinition("default").setBuildEdition(true); //$NON-NLS-1$
-					
-					Log.info(NLS.bind(TXMUIMessages.theP0CorpusWillBeCreatedFromTheP1Directory, project.getName(), project.getSrcdir()));
-					
-					Engine e = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger"); //$NON-NLS-1$
-					if (e != null) {
-						project.setAnnotate(e.isRunning());
-					}
-					
-					if (project.getAnnotate()) {
-						Log.info(TXMUIMessages.TheAnnotateImportParameterHasBeenActivatedSinceTreeTaggerIsInstalled);
-					}
-					else {
-						Log.info(TXMUIMessages.TheAnnotateImportParameterWasNotActivatedSinceTreeTaggerIsNotInstalled);
-					}
-					
-					File importxml = new File(page1.getSourcePath(), "import.xml"); //$NON-NLS-1$
-					if (importxml.exists()) {
-						System.out.println(TXMUIMessages.AnImportDotXMLImportConfigurationFileWasFoundRestoringImportParametersUsingThisfile);
-						BaseOldParameters params = new BaseOldParameters(importxml);
-						params.load();
-						params.initializeProject(project);
-					}
+				project.setSourceDirectory(path.getAbsolutePath());
+				project.setDescription(NLS.bind(TXMUIMessages.DashImportedByP0, System.getProperty("user.name"))); //$NON-NLS-2$
+				project.setLang(Locale.getDefault().getLanguage().toLowerCase());
+				
+				project.getEditionDefinition("default").setEnableCollapsible(false); //$NON-NLS-1$
+				project.getEditionDefinition("default").setPageBreakTag("pb"); //$NON-NLS-1$ //$NON-NLS-2$
+				project.getEditionDefinition("default").setPaginateEdition(true); //$NON-NLS-1$
+				project.getEditionDefinition("default").setWordsPerPage(1000); //$NON-NLS-1$
+				project.getEditionDefinition("default").setBuildEdition(true); //$NON-NLS-1$
+				
+				Log.info(NLS.bind(TXMUIMessages.theP0CorpusWillBeCreatedFromTheP1Directory, project.getName(), project.getSrcdir()));
+				
+				Engine e = Toolbox.getEngineManager(EngineType.ANNOTATION).getEngine("TreeTagger"); //$NON-NLS-1$
+				if (e != null) {
+					project.setAnnotate(e.isRunning());
 				}
+				
+				if (project.getAnnotate()) {
+					Log.info(TXMUIMessages.TheAnnotateImportParameterHasBeenActivatedSinceTreeTaggerIsInstalled);
+				}
 				else {
-					Date date = project.getLastComputingDate();
-					if (date == null) {
-						date = Calendar.getInstance().getTime(); // today
-					}
-					
-//					if (MessageDialog.openQuestion(ImportWizard.this.getShell(), NLS.bind(TXMUIMessages.p0Import, project), NLS.bind(TXMUIMessages.theP1P0CorpusWillBeReplaced+"\nContinue ?", project, date))) {
-						Log.info(NLS.bind(TXMUIMessages.theP1P0CorpusWillBeReplaced, project, date));
-//					} else {
-//						Log.info(TXMUIMessages.abort);
-//						return false;
-//					}
-					
-					
+					Log.info(TXMUIMessages.TheAnnotateImportParameterWasNotActivatedSinceTreeTaggerIsNotInstalled);
 				}
 				
-				// if (!project.hasEditionDefinition("default")) {
-				// EditionDefinition def = project.getEditionDefinition("default");
-				// def.setBuildEdition(true);
-				// def.setWordsPerPage(1000);
-				// def.setPageBreakTag("pb");
-				// }
+				File importxml = new File(path, "import.xml"); //$NON-NLS-1$
+				if (importxml.exists()) {
+					System.out.println(TXMUIMessages.AnImportDotXMLImportConfigurationFileWasFoundRestoringImportParametersUsingThisfile);
+					BaseOldParameters params = new BaseOldParameters(importxml);
+					params.load();
+					params.initializeProject(project);
+				}
+			}
+			else {
+				Date date = project.getLastComputingDate();
+				if (date == null) {
+					date = Calendar.getInstance().getTime(); // today
+				}
 				
-				project.setDoUpdate(false, false);
-				project.saveParameters();
-				return true;
+//				if (MessageDialog.openQuestion(ImportWizard.this.getShell(), NLS.bind(TXMUIMessages.p0Import, project), NLS.bind(TXMUIMessages.theP1P0CorpusWillBeReplaced+"\nContinue ?", project, date))) {
+					Log.info(NLS.bind(TXMUIMessages.theP1P0CorpusWillBeReplaced, project, date));
+//				} else {
+//					Log.info(TXMUIMessages.abort);
+//					return false;
+//				}
+				
+				
 			}
-			catch (Exception e) {
-				e.printStackTrace();
-				return false;
-			}
+			
+			// if (!project.hasEditionDefinition("default")) {
+			// EditionDefinition def = project.getEditionDefinition("default");
+			// def.setBuildEdition(true);
+			// def.setWordsPerPage(1000);
+			// def.setPageBreakTag("pb");
+			// }
+			
+			project.setDoUpdate(false, false);
+			project.saveParameters();
+			return project;
 		}
-		return false;
+		catch (Exception e) {
+			e.printStackTrace();
+			return null;
+		}
 	}
-	
+
 	@Override
 	public void addPages() {
 		addPage(page1);
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/RevertTXMResult.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/RevertTXMResult.java	(revision 0)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/RevertTXMResult.java	(revision 3628)
@@ -0,0 +1,59 @@
+package org.txm.rcp.handlers.results;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.swt.widgets.Event;
+import org.eclipse.swt.widgets.ToolBar;
+import org.eclipse.swt.widgets.ToolItem;
+import org.txm.core.results.TXMResult;
+import org.txm.rcp.editors.TXMEditorToolBar;
+import org.txm.utils.logger.Log;
+
+/**
+ * Calls TXMEditor.compute() on the current active editor.
+ * 
+ * @author mdecorde
+ *
+ */
+public class RevertTXMResult extends AbstractHandler {
+
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+
+		try {
+			revert(event);
+		} catch (Exception e) {
+			Log.severe(e);
+			Log.printStackTrace(e);
+		}
+
+		return null;
+	}
+	
+	public static Object revert(ExecutionEvent event) throws Exception {
+		
+		Object trigger = event.getTrigger();
+
+		if (trigger instanceof Event) {
+			Event e = (Event) trigger;
+			if (e.widget instanceof ToolItem) {
+				ToolItem ti = (ToolItem) e.widget;
+				ToolBar parent = ti.getParent();
+				if (parent instanceof TXMEditorToolBar) {
+					TXMResult result = ((TXMEditorToolBar)parent).getEditorPart().getResult();
+					ArrayList<HashMap<String, Object>> history = result.getParametersHistory();
+					if (history != null && history.size() > 0) {
+						result.revertParametersFromHistory();
+						return ((TXMEditorToolBar)parent).getEditorPart().compute(true);
+					}
+					return null;
+				}
+			}
+		}
+		return null;
+	}
+}

Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/ComputeTXMResult.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/ComputeTXMResult.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/ComputeTXMResult.java	(revision 3628)
@@ -6,10 +6,6 @@
 import org.eclipse.swt.widgets.Event;
 import org.eclipse.swt.widgets.ToolBar;
 import org.eclipse.swt.widgets.ToolItem;
-import org.eclipse.ui.IEditorPart;
-import org.eclipse.ui.IWorkbenchPart;
-import org.eclipse.ui.handlers.HandlerUtil;
-import org.txm.rcp.editors.TXMEditor;
 import org.txm.rcp.editors.TXMEditorToolBar;
 
 /**
@@ -23,27 +19,14 @@
 
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
-		IWorkbenchPart part = HandlerUtil.getActiveWorkbenchWindow(event).getActivePage().getActivePart();
-		IEditorPart activeEditor = HandlerUtil.getActiveWorkbenchWindow(event).getActivePage().getActiveEditor();
 
 		compute(event);
-		// gets the main editor if the active editor is a multipages editor
-//		if(part instanceof TXMMultiPageEditor)	{
-//			part = (IWorkbenchPart) ((TXMMultiPageEditor)part).getEditors().get(0);
-//		}
-//		
-//		if (!(part instanceof TXMEditor)) {
-//			System.out.println("Active editor is not a TXMEditor. Aborting.");
-//			return null;
-//		}
-//
-//		TXMEditor editor = (TXMEditor) part;
-//		editor.compute(true);
 
 		return null;
 	}
 	
 	public static Object compute(ExecutionEvent event) {
+		
 		Object trigger = event.getTrigger();
 
 		if (trigger instanceof Event) {
Index: TXM/trunk/org.txm.rcp/SUBVERSION
===================================================================
--- TXM/trunk/org.txm.rcp/SUBVERSION	(revision 3627)
+++ TXM/trunk/org.txm.rcp/SUBVERSION	(revision 3628)
@@ -0,0 +1 @@
+alpha
